Index: kernel/generic/include/macros.h
===================================================================
--- kernel/generic/include/macros.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/include/macros.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -52,19 +52,8 @@
     uint64_t sz2)
 {
-	uint64_t e1 = s1 + sz1 - 1;
-	uint64_t e2 = s2 + sz2 - 1;
-
-	/* both sizes are non-zero */
-	if (sz1 && sz2)
-		return ((s1 <= e2) && (s2 <= e1));
-
-	/* one size is non-zero */
-	if (sz2)
-		return ((s1 >= s2) && (s1 <= e2));
-	if (sz1)
-		return ((s2 >= s1) && (s2 <= e1));
-
-	/* both are zero */
-	return (s1 == s2);
+	uint64_t e1 = s1 + sz1;
+	uint64_t e2 = s2 + sz2;
+	
+	return ((s1 < e2) && (s2 < e1));
 }
 
@@ -130,12 +119,4 @@
 	    | ((((uint64_t) (up)) & UINT32_C(0xffffffff)) << 32))
 
-/* Test for sum overflow. */
-#define overflows(a, b) \
-	((a) + (b) < (a))
-
-/* Test for sum overflow into positive numbers. */
-#define overflows_into_positive(a, b)	\
-	(overflows((a), (b)) && ((a) + (b) > 0))
-
 /** Pseudorandom generator
  *
Index: kernel/generic/include/mm/as.h
===================================================================
--- kernel/generic/include/mm/as.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/include/mm/as.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -61,4 +61,10 @@
 #define USER_ADDRESS_SPACE_END      USER_ADDRESS_SPACE_END_ARCH
 
+#ifdef USTACK_ADDRESS_ARCH
+	#define USTACK_ADDRESS  USTACK_ADDRESS_ARCH
+#else
+	#define USTACK_ADDRESS  (USER_ADDRESS_SPACE_END - (STACK_SIZE - 1))
+#endif
+
 /** Kernel address space. */
 #define FLAG_AS_KERNEL  (1 << 0)
@@ -68,15 +74,12 @@
 #define AS_AREA_ATTR_PARTIAL  1  /**< Not fully initialized area. */
 
+/** The page fault was not resolved by as_page_fault(). */
+#define AS_PF_FAULT  0
+
 /** The page fault was resolved by as_page_fault(). */
-#define AS_PF_OK     0 
+#define AS_PF_OK  1
 
 /** The page fault was caused by memcpy_from_uspace() or memcpy_to_uspace(). */
-#define AS_PF_DEFER  1
-
-/** The page fault was not resolved by as_page_fault(). */
-#define AS_PF_FAULT  2
-
-/** The page fault was not resolved by as_page_fault(). Non-verbose version. */
-#define AS_PF_SILENT 3
+#define AS_PF_DEFER  2
 
 /** Address space structure.
@@ -221,7 +224,4 @@
 	void (* destroy)(as_area_t *);
 
-	bool (* is_resizable)(as_area_t *);
-	bool (* is_shareable)(as_area_t *);
-
 	int (* page_fault)(as_area_t *, uintptr_t, pf_access_t);
 	void (* frame_free)(as_area_t *, uintptr_t, uintptr_t);
Index: kernel/generic/src/console/cmd.c
===================================================================
--- kernel/generic/src/console/cmd.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/src/console/cmd.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -56,5 +56,4 @@
 #include <cpu.h>
 #include <mm/tlb.h>
-#include <mm/km.h>
 #include <arch/mm/tlb.h>
 #include <mm/frame.h>
@@ -82,79 +81,4 @@
 	.func = cmd_help,
 	.argc = 0
-};
-
-/* Data and methods for pio_read_8 command */
-static int cmd_pio_read_8(cmd_arg_t *argv);
-static cmd_arg_t pio_read_8_argv[] = { { .type = ARG_TYPE_INT } };
-static cmd_info_t pio_read_8_info = {
-	.name = "pio_read_8",
-	.description = "pio_read_8 <address> Read 1 byte from memory (or port).",
-	.func = cmd_pio_read_8,
-	.argc = 1,
-	.argv = pio_read_8_argv
-};
-
-/* Data and methods for pio_read_16 command */
-static int cmd_pio_read_16(cmd_arg_t *argv);
-static cmd_arg_t pio_read_16_argv[] = { { .type = ARG_TYPE_INT } };
-static cmd_info_t pio_read_16_info = {
-	.name = "pio_read_16",
-	.description = "pio_read_16 <address> Read 2 bytes from memory (or port).",
-	.func = cmd_pio_read_16,
-	.argc = 1,
-	.argv = pio_read_16_argv
-};
-
-/* Data and methods for pio_read_32 command */
-static int cmd_pio_read_32(cmd_arg_t *argv);
-static cmd_arg_t pio_read_32_argv[] = { { .type = ARG_TYPE_INT } };
-static cmd_info_t pio_read_32_info = {
-	.name = "pio_read_32",
-	.description = "pio_read_32 <address> Read 4 bytes from memory (or port).",
-	.func = cmd_pio_read_32,
-	.argc = 1,
-	.argv = pio_read_32_argv
-};
-
-/* Data and methods for pio_write_8 command */
-static int cmd_pio_write_8(cmd_arg_t *argv);
-static cmd_arg_t pio_write_8_argv[] = {
-	{ .type = ARG_TYPE_INT },
-	{ .type = ARG_TYPE_INT }
-};
-static cmd_info_t pio_write_8_info = {
-	.name = "pio_write_8",
-	.description = "pio_write_8 <address> <value> Write 1 byte to memory (or port).",
-	.func = cmd_pio_write_8,
-	.argc = 2,
-	.argv = pio_write_8_argv
-};
-
-/* Data and methods for pio_write_16 command */
-static int cmd_pio_write_16(cmd_arg_t *argv);
-static cmd_arg_t pio_write_16_argv[] = {
-	{ .type = ARG_TYPE_INT },
-	{ .type = ARG_TYPE_INT }
-};
-static cmd_info_t pio_write_16_info = {
-	.name = "pio_write_16",
-	.description = "pio_write_16 <address> <value> Write 2 bytes to memory (or port).",
-	.func = cmd_pio_write_16,
-	.argc = 2,
-	.argv = pio_write_16_argv
-};
-
-/* Data and methods for pio_write_32 command */
-static int cmd_pio_write_32(cmd_arg_t *argv);
-static cmd_arg_t pio_write_32_argv[] = {
-	{ .type = ARG_TYPE_INT },
-	{ .type = ARG_TYPE_INT }
-};
-static cmd_info_t pio_write_32_info = {
-	.name = "pio_write_32",
-	.description = "pio_write_32 <address> <value> Write 4 bytes to memory (or port).",
-	.func = cmd_pio_write_32,
-	.argc = 2,
-	.argv = pio_write_32_argv
 };
 
@@ -607,10 +531,4 @@
 	&btrace_info,
 #endif
-	&pio_read_8_info,
-	&pio_read_16_info,
-	&pio_read_32_info,
-	&pio_write_8_info,
-	&pio_write_16_info,
-	&pio_write_32_info,
 	NULL
 };
@@ -683,187 +601,4 @@
 	spinlock_unlock(&cmd_lock);
 	
-	return 1;
-}
-
-/** Read 1 byte from phys memory or io port.
- *
- * @param argv Argument vector.
- *
- * @return 0 on failure, 1 on success.
- */
-static int cmd_pio_read_8(cmd_arg_t *argv)
-{
-	uint8_t *ptr = NULL;
-	
-#ifdef IO_SPACE_BOUNDARY
-	if ((void *) argv->intval < IO_SPACE_BOUNDARY)
-		ptr = (void *) argv[0].intval;
-	else
-#endif
-		ptr = (uint8_t *) km_map(argv[0].intval, sizeof(uint8_t),
-		    PAGE_NOT_CACHEABLE);
-	
-	const uint8_t val = pio_read_8(ptr);
-	printf("read %" PRIxn ": %" PRIx8 "\n", argv[0].intval, val);
-	
-#ifdef IO_SPACE_BOUNDARY
-	if ((void *) argv->intval < IO_SPACE_BOUNDARY)
-		return 1;
-#endif
-	
-	km_unmap((uintptr_t) ptr, sizeof(uint8_t));
-	return 1;
-}
-
-/** Read 2 bytes from phys memory or io port.
- *
- * @param argv Argument vector.
- *
- * @return 0 on failure, 1 on success.
- */
-static int cmd_pio_read_16(cmd_arg_t *argv)
-{
-	uint16_t *ptr = NULL;
-	
-#ifdef IO_SPACE_BOUNDARY
-	if ((void *) argv->intval < IO_SPACE_BOUNDARY)
-		ptr = (void *) argv[0].intval;
-	else
-#endif
-		ptr = (uint16_t *) km_map(argv[0].intval, sizeof(uint16_t),
-		    PAGE_NOT_CACHEABLE);
-	
-	const uint16_t val = pio_read_16(ptr);
-	printf("read %" PRIxn ": %" PRIx16 "\n", argv[0].intval, val);
-	
-#ifdef IO_SPACE_BOUNDARY
-	if ((void *) argv->intval < IO_SPACE_BOUNDARY)
-		return 1;
-#endif
-	
-	km_unmap((uintptr_t) ptr, sizeof(uint16_t));
-	return 1;
-}
-
-/** Read 4 bytes from phys memory or io port.
- *
- * @param argv Argument vector.
- *
- * @return 0 on failure, 1 on success.
- */
-static int cmd_pio_read_32(cmd_arg_t *argv)
-{
-	uint32_t *ptr = NULL;
-	
-#ifdef IO_SPACE_BOUNDARY
-	if ((void *) argv->intval < IO_SPACE_BOUNDARY)
-		ptr = (void *) argv[0].intval;
-	else
-#endif
-		ptr = (uint32_t *) km_map(argv[0].intval, sizeof(uint32_t),
-		    PAGE_NOT_CACHEABLE);
-	
-	const uint32_t val = pio_read_32(ptr);
-	printf("read %" PRIxn ": %" PRIx32 "\n", argv[0].intval, val);
-	
-#ifdef IO_SPACE_BOUNDARY
-	if ((void *) argv->intval < IO_SPACE_BOUNDARY)
-		return 1;
-#endif
-	
-	km_unmap((uintptr_t) ptr, sizeof(uint32_t));
-	return 1;
-}
-
-/** Write 1 byte to phys memory or io port.
- *
- * @param argv Argument vector.
- *
- * @return 0 on failure, 1 on success.
- */
-static int cmd_pio_write_8(cmd_arg_t *argv)
-{
-	uint8_t *ptr = NULL;
-	
-#ifdef IO_SPACE_BOUNDARY
-	if ((void *) argv->intval < IO_SPACE_BOUNDARY)
-		ptr = (void *) argv[0].intval;
-	else
-#endif
-		ptr = (uint8_t *) km_map(argv[0].intval, sizeof(uint8_t),
-		    PAGE_NOT_CACHEABLE);
-	
-	printf("write %" PRIxn ": %" PRIx8 "\n", argv[0].intval,
-	    (uint8_t) argv[1].intval);
-	pio_write_8(ptr, (uint8_t) argv[1].intval);
-	
-#ifdef IO_SPACE_BOUNDARY
-	if ((void *) argv->intval < IO_SPACE_BOUNDARY)
-		return 1;
-#endif
-	
-	km_unmap((uintptr_t) ptr, sizeof(uint8_t));
-	return 1;
-}
-
-/** Write 2 bytes to phys memory or io port.
- *
- * @param argv Argument vector.
- *
- * @return 0 on failure, 1 on success.
- */
-static int cmd_pio_write_16(cmd_arg_t *argv)
-{
-	uint16_t *ptr = NULL;
-	
-#ifdef IO_SPACE_BOUNDARY
-	if ((void *) argv->intval < IO_SPACE_BOUNDARY)
-		ptr = (void *) argv[0].intval;
-	else
-#endif
-		ptr = (uint16_t *) km_map(argv[0].intval, sizeof(uint16_t),
-		    PAGE_NOT_CACHEABLE);
-	
-	printf("write %" PRIxn ": %" PRIx16 "\n", argv[0].intval,
-	    (uint16_t) argv[1].intval);
-	pio_write_16(ptr, (uint16_t) argv[1].intval);
-	
-#ifdef IO_SPACE_BOUNDARY
-	if ((void *) argv->intval < IO_SPACE_BOUNDARY)
-		return 1;
-#endif
-	
-	km_unmap((uintptr_t) ptr, sizeof(uint16_t));
-	return 1;
-}
-
-/** Write 4 bytes to phys memory or io port.
- *
- * @param argv Argument vector.
- *
- * @return 0 on failure, 1 on success.
- */
-static int cmd_pio_write_32(cmd_arg_t *argv)
-{
-	uint32_t *ptr = NULL;
-	
-#ifdef IO_SPACE_BOUNDARY
-	if ((void *) argv->intval < IO_SPACE_BOUNDARY)
-		ptr = (void *) argv[0].intval;
-	else
-#endif
-		ptr = (uint32_t *) km_map(argv[0].intval, sizeof(uint32_t),
-		    PAGE_NOT_CACHEABLE);
-	
-	printf("write %" PRIxn ": %" PRIx32 "\n", argv[0].intval,
-	    (uint32_t) argv[1].intval);
-	pio_write_32(ptr, (uint32_t) argv[1].intval);
-	
-#ifdef IO_SPACE_BOUNDARY
-	if ((void *) argv->intval < IO_SPACE_BOUNDARY)
-		return 1;
-#endif
-	
-	km_unmap((uintptr_t) ptr, sizeof(uint32_t));
 	return 1;
 }
Index: kernel/generic/src/console/console.c
===================================================================
--- kernel/generic/src/console/console.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/src/console/console.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -52,5 +52,4 @@
 #include <errno.h>
 #include <str.h>
-#include <abi/klog.h>
 
 #define KLOG_PAGES    8
@@ -336,20 +335,9 @@
  *
  */
-sysarg_t sys_klog(int cmd, const void *buf, size_t size)
+sysarg_t sys_klog(int fd, const void *buf, size_t size)
 {
 	char *data;
 	int rc;
-
-	switch (cmd) {
-	case KLOG_UPDATE:
-		klog_update(NULL);
-		return EOK;
-	case KLOG_WRITE:
-	case KLOG_COMMAND:
-		break;
-	default:
-		return ENOTSUP;
-	}
-
+	
 	if (size > PAGE_SIZE)
 		return (sysarg_t) ELIMIT;
@@ -367,20 +355,9 @@
 		data[size] = 0;
 		
-		switch (cmd) {
-		case KLOG_WRITE:
-			printf("%s", data);
-			break;
-		case KLOG_COMMAND:
-			if (!stdin)
-				break;
-			for (unsigned int i = 0; i < size; i++)
-				indev_push_character(stdin, data[i]);
-			indev_push_character(stdin, '\n');
-			break;
-		}
-
+		printf("%s", data);
 		free(data);
-	}
-
+	} else
+		klog_update(NULL);
+	
 	return size;
 }
Index: kernel/generic/src/console/kconsole.c
===================================================================
--- kernel/generic/src/console/kconsole.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/src/console/kconsole.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -524,14 +524,11 @@
 		/* It's a number - convert it */
 		uint64_t value;
-		char *end;
-		int rc = str_uint64_t(text, &end, 0, false, &value);
-		if (end != text + len)
-			rc = EINVAL;
+		int rc = str_uint64_t(text, NULL, 0, true, &value);
 		switch (rc) {
 		case EINVAL:
-			printf("Invalid number '%s'.\n", text);
+			printf("Invalid number.\n");
 			return false;
 		case EOVERFLOW:
-			printf("Integer overflow in '%s'.\n", text);
+			printf("Integer overflow.\n");
 			return false;
 		case EOK:
@@ -541,5 +538,5 @@
 			break;
 		default:
-			printf("Unknown error parsing '%s'.\n", text);
+			printf("Unknown error.\n");
 			return false;
 		}
Index: kernel/generic/src/interrupt/interrupt.c
===================================================================
--- kernel/generic/src/interrupt/interrupt.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/src/interrupt/interrupt.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -166,6 +166,5 @@
 }
 
-static NO_TRACE
-void fault_from_uspace_core(istate_t *istate, const char *fmt, va_list args)
+static NO_TRACE void fault_from_uspace_core(istate_t *istate, const char *fmt, va_list args)
 {
 	printf("Task %s (%" PRIu64 ") killed due to an exception at "
Index: kernel/generic/src/main/kinit.c
===================================================================
--- kernel/generic/src/main/kinit.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/src/main/kinit.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -172,10 +172,4 @@
 #endif /* CONFIG_KCONSOLE */
 	
-	/*
-	 * Store the default stack size in sysinfo so that uspace can create
-	 * stack with this default size.
-	 */
-	sysinfo_set_item_val("default.stack_size", NULL, STACK_SIZE_USER);
-	
 	interrupts_enable();
 	
@@ -250,14 +244,6 @@
 				    CAP_IO_MANAGER | CAP_IRQ_REG);
 				
-				if (!ipc_phone_0) {
+				if (!ipc_phone_0)
 					ipc_phone_0 = &programs[i].task->answerbox;
-					/*
-					 * Hold the first task so that the
-					 * ipc_phone_0 remains a valid pointer
-					 * even if the first task exits for
-					 * whatever reason.
-					 */
-					task_hold(programs[i].task);
-				}
 			}
 			
Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/src/mm/as.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -79,5 +79,4 @@
 #include <syscall/copy.h>
 #include <arch/interrupt.h>
-#include <interrupt.h>
 
 /**
@@ -286,9 +285,8 @@
 /** Check area conflicts with other areas.
  *
- * @param as      Address space.
- * @param addr    Starting virtual address of the area being tested.
- * @param count   Number of pages in the area being tested.
- * @param guarded True if the area being tested is protected by guard pages.
- * @param avoid   Do not touch this area.
+ * @param as    Address space.
+ * @param addr  Starting virtual address of the area being tested.
+ * @param count Number of pages in the area being tested.
+ * @param avoid Do not touch this area.
  *
  * @return True if there is no conflict, false otherwise.
@@ -296,15 +294,8 @@
  */
 NO_TRACE static bool check_area_conflicts(as_t *as, uintptr_t addr,
-    size_t count, bool guarded, as_area_t *avoid)
+    size_t count, as_area_t *avoid)
 {
 	ASSERT((addr % PAGE_SIZE) == 0);
 	ASSERT(mutex_locked(&as->lock));
-
-	/*
-	 * If the addition of the supposed area address and size overflows,
-	 * report conflict.
-	 */
-	if (overflows_into_positive(addr, P2SZ(count)))
-		return false;
 	
 	/*
@@ -313,5 +304,5 @@
 	if (overlaps(addr, P2SZ(count), (uintptr_t) NULL, PAGE_SIZE))
 		return false;
-
+	
 	/*
 	 * The leaf node is found in O(log n), where n is proportional to
@@ -337,51 +328,6 @@
 		if (area != avoid) {
 			mutex_lock(&area->lock);
-
-			/*
-			 * If at least one of the two areas are protected
-			 * by the AS_AREA_GUARD flag then we must be sure
-			 * that they are separated by at least one unmapped
-			 * page.
-			 */
-			int const gp = (guarded || 
-			    (area->flags & AS_AREA_GUARD)) ? 1 : 0;
-			
-			/*
-			 * The area comes from the left neighbour node, which
-			 * means that there already are some areas in the leaf
-			 * node, which in turn means that adding gp is safe and
-			 * will not cause an integer overflow.
-			 */
+			
 			if (overlaps(addr, P2SZ(count), area->base,
-			    P2SZ(area->pages + gp))) {
-				mutex_unlock(&area->lock);
-				return false;
-			}
-			
-			mutex_unlock(&area->lock);
-		}
-	}
-	
-	node = btree_leaf_node_right_neighbour(&as->as_area_btree, leaf);
-	if (node) {
-		area = (as_area_t *) node->value[0];
-		
-		if (area != avoid) {
-			int gp;
-
-			mutex_lock(&area->lock);
-
-			gp = (guarded || (area->flags & AS_AREA_GUARD)) ? 1 : 0;
-			if (gp && overflows(addr, P2SZ(count))) {
-				/*
-				 * Guard page not needed if the supposed area
-				 * is adjacent to the end of the address space.
-				 * We already know that the following test is
-				 * going to fail...
-				 */
-				gp--;
-			}
-			
-			if (overlaps(addr, P2SZ(count + gp), area->base,
 			    P2SZ(area->pages))) {
 				mutex_unlock(&area->lock);
@@ -393,10 +339,25 @@
 	}
 	
+	node = btree_leaf_node_right_neighbour(&as->as_area_btree, leaf);
+	if (node) {
+		area = (as_area_t *) node->value[0];
+		
+		if (area != avoid) {
+			mutex_lock(&area->lock);
+			
+			if (overlaps(addr, P2SZ(count), area->base,
+			    P2SZ(area->pages))) {
+				mutex_unlock(&area->lock);
+				return false;
+			}
+			
+			mutex_unlock(&area->lock);
+		}
+	}
+	
 	/* Second, check the leaf node. */
 	btree_key_t i;
 	for (i = 0; i < leaf->keys; i++) {
 		area = (as_area_t *) leaf->value[i];
-		int agp;
-		int gp;
 		
 		if (area == avoid)
@@ -404,18 +365,7 @@
 		
 		mutex_lock(&area->lock);
-
-		gp = (guarded || (area->flags & AS_AREA_GUARD)) ? 1 : 0;
-		agp = gp;
-
-		/*
-		 * Sanitize the two possible unsigned integer overflows.
-		 */
-		if (gp && overflows(addr, P2SZ(count)))
-			gp--;
-		if (agp && overflows(area->base, P2SZ(area->pages)))
-			agp--;
-
-		if (overlaps(addr, P2SZ(count + gp), area->base,
-		    P2SZ(area->pages + agp))) {
+		
+		if (overlaps(addr, P2SZ(count), area->base,
+		    P2SZ(area->pages))) {
 			mutex_unlock(&area->lock);
 			return false;
@@ -427,10 +377,9 @@
 	/*
 	 * So far, the area does not conflict with other areas.
-	 * Check if it is contained in the user address space.
+	 * Check if it doesn't conflict with kernel address space.
 	 */
 	if (!KERNEL_ADDRESS_SPACE_SHADOWED) {
-		return iswithin(USER_ADDRESS_SPACE_START,
-		    (USER_ADDRESS_SPACE_END - USER_ADDRESS_SPACE_START) + 1,
-		    addr, P2SZ(count));
+		return !overlaps(addr, P2SZ(count), KERNEL_ADDRESS_SPACE_START,
+		    KERNEL_ADDRESS_SPACE_END - KERNEL_ADDRESS_SPACE_START);
 	}
 	
@@ -443,8 +392,7 @@
  * this function.
  *
- * @param as      Address space.
- * @param bound   Lowest address bound.
- * @param size    Requested size of the allocation.
- * @param guarded True if the allocation must be protected by guard pages.
+ * @param as    Address space.
+ * @param bound Lowest address bound.
+ * @param size  Requested size of the allocation.
  *
  * @return Address of the beginning of unmapped address space area.
@@ -453,5 +401,5 @@
  */
 NO_TRACE static uintptr_t as_get_unmapped_area(as_t *as, uintptr_t bound,
-    size_t size, bool guarded)
+    size_t size)
 {
 	ASSERT(mutex_locked(&as->lock));
@@ -475,15 +423,7 @@
 	/* First check the bound address itself */
 	uintptr_t addr = ALIGN_UP(bound, PAGE_SIZE);
-	if (addr >= bound) {
-		if (guarded) {
-			/* Leave an unmapped page between the lower
-			 * bound and the area's start address.
-			 */
-			addr += P2SZ(1);
-		}
-
-		if (check_area_conflicts(as, addr, pages, guarded, NULL))
-			return addr;
-	}
+	if ((addr >= bound) &&
+	    (check_area_conflicts(as, addr, pages, NULL)))
+		return addr;
 	
 	/* Eventually check the addresses behind each area */
@@ -499,15 +439,7 @@
 			addr =
 			    ALIGN_UP(area->base + P2SZ(area->pages), PAGE_SIZE);
-
-			if (guarded || area->flags & AS_AREA_GUARD) {
-				/* We must leave an unmapped page
-				 * between the two areas.
-				 */
-				addr += P2SZ(1);
-			}
-
 			bool avail =
 			    ((addr >= bound) && (addr >= area->base) &&
-			    (check_area_conflicts(as, addr, pages, guarded, area)));
+			    (check_area_conflicts(as, addr, pages, area)));
 			
 			mutex_unlock(&area->lock);
@@ -549,5 +481,5 @@
 	if (size == 0)
 		return NULL;
-
+	
 	size_t pages = SIZE2FRAMES(size);
 	
@@ -555,11 +487,9 @@
 	if ((flags & AS_AREA_EXEC) && (flags & AS_AREA_WRITE))
 		return NULL;
-
-	bool const guarded = flags & AS_AREA_GUARD;
 	
 	mutex_lock(&as->lock);
 	
 	if (*base == (uintptr_t) -1) {
-		*base = as_get_unmapped_area(as, bound, size, guarded);
+		*base = as_get_unmapped_area(as, bound, size);
 		if (*base == (uintptr_t) -1) {
 			mutex_unlock(&as->lock);
@@ -567,9 +497,6 @@
 		}
 	}
-
-	if (overflows_into_positive(*base, size))
-		return NULL;
-
-	if (!check_area_conflicts(as, *base, pages, guarded, NULL)) {
+	
+	if (!check_area_conflicts(as, *base, pages, NULL)) {
 		mutex_unlock(&as->lock);
 		return NULL;
@@ -698,8 +625,9 @@
 		return ENOENT;
 	}
-
-	if (!area->backend->is_resizable(area)) {
+	
+	if (area->backend == &phys_backend) {
 		/*
-		 * The backend does not support resizing for this area.
+		 * Remapping of address space areas associated
+		 * with memory mapped devices is not supported.
 		 */
 		mutex_unlock(&area->lock);
@@ -848,14 +776,7 @@
 		/*
 		 * Growing the area.
-		 */
-
-		if (overflows_into_positive(address, P2SZ(pages)))
-			return EINVAL;
-
-		/*
 		 * Check for overlaps with other address space areas.
 		 */
-		bool const guarded = area->flags & AS_AREA_GUARD;
-		if (!check_area_conflicts(as, address, pages, guarded, area)) {
+		if (!check_area_conflicts(as, address, pages, area)) {
 			mutex_unlock(&area->lock);
 			mutex_unlock(&as->lock);
@@ -1058,7 +979,8 @@
 	}
 	
-	if (!src_area->backend->is_shareable(src_area)) {
+	if ((!src_area->backend) || (!src_area->backend->share)) {
 		/*
-		 * The backend does not permit sharing of this area.
+		 * There is no backend or the backend does not
+		 * know how to share the area.
 		 */
 		mutex_unlock(&src_area->lock);
@@ -1363,11 +1285,9 @@
 int as_page_fault(uintptr_t page, pf_access_t access, istate_t *istate)
 {
-	int rc = AS_PF_FAULT;
-
 	if (!THREAD)
-		goto page_fault;
+		return AS_PF_FAULT;
 	
 	if (!AS)
-		goto page_fault;
+		return AS_PF_FAULT;
 	
 	mutex_lock(&AS->lock);
@@ -1425,6 +1345,5 @@
 	 * Resort to the backend page fault handler.
 	 */
-	rc = area->backend->page_fault(area, page, access);
-	if (rc != AS_PF_OK) {
+	if (area->backend->page_fault(area, page, access) != AS_PF_OK) {
 		page_table_unlock(AS, false);
 		mutex_unlock(&area->lock);
@@ -1447,11 +1366,6 @@
 		istate_set_retaddr(istate,
 		    (uintptr_t) &memcpy_to_uspace_failover_address);
-	} else if (rc == AS_PF_SILENT) {
-		printf("Killing task %" PRIu64 " due to a "
-		    "failed late reservation request.\n", TASK->taskid);
-		task_kill_self(true);
 	} else {
-		fault_if_from_uspace(istate, "Page fault: %p.", (void *) page);
-		panic_memtrap(istate, access, page, NULL);
+		return AS_PF_FAULT;
 	}
 	
@@ -2140,5 +2054,5 @@
 {
 	uintptr_t virt = base;
-	as_area_t *area = as_area_create(AS, flags, size,
+	as_area_t *area = as_area_create(AS, flags | AS_AREA_CACHEABLE, size,
 	    AS_AREA_ATTR_NONE, &anon_backend, NULL, &virt, bound);
 	if (area == NULL)
Index: kernel/generic/src/mm/backend_anon.c
===================================================================
--- kernel/generic/src/mm/backend_anon.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/src/mm/backend_anon.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -59,7 +59,4 @@
 static void anon_destroy(as_area_t *);
 
-static bool anon_is_resizable(as_area_t *);
-static bool anon_is_shareable(as_area_t *);
-
 static int anon_page_fault(as_area_t *, uintptr_t, pf_access_t);
 static void anon_frame_free(as_area_t *, uintptr_t, uintptr_t);
@@ -71,7 +68,4 @@
 	.destroy = anon_destroy,
 
-	.is_resizable = anon_is_resizable,
-	.is_shareable = anon_is_shareable,
-
 	.page_fault = anon_page_fault,
 	.frame_free = anon_frame_free,
@@ -80,7 +74,4 @@
 bool anon_create(as_area_t *area)
 {
-	if (area->flags & AS_AREA_LATE_RESERVE)
-		return true;
-
 	return reserve_try_alloc(area->pages);
 }
@@ -88,7 +79,4 @@
 bool anon_resize(as_area_t *area, size_t new_pages)
 {
-	if (area->flags & AS_AREA_LATE_RESERVE)
-		return true;
-
 	if (new_pages > area->pages)
 		return reserve_try_alloc(new_pages - area->pages);
@@ -112,5 +100,4 @@
 	ASSERT(mutex_locked(&area->as->lock));
 	ASSERT(mutex_locked(&area->lock));
-	ASSERT(!(area->flags & AS_AREA_LATE_RESERVE));
 
 	/*
@@ -152,19 +139,7 @@
 void anon_destroy(as_area_t *area)
 {
-	if (area->flags & AS_AREA_LATE_RESERVE)
-		return;
-
 	reserve_free(area->pages);
 }
 
-bool anon_is_resizable(as_area_t *area)
-{
-	return true;
-}
-
-bool anon_is_shareable(as_area_t *area)
-{
-	return !(area->flags & AS_AREA_LATE_RESERVE);
-}
 
 /** Service a page fault in the anonymous memory address space area.
@@ -250,13 +225,4 @@
 		 *   the different causes
 		 */
-
-		if (area->flags & AS_AREA_LATE_RESERVE) {
-			/*
-			 * Reserve the memory for this page now.
-			 */
-			if (!reserve_try_alloc(1))
-				return AS_PF_SILENT;
-		}
-
 		kpage = km_temporary_page_get(&frame, FRAME_NO_RESERVE);
 		memsetb((void *) kpage, PAGE_SIZE, 0);
@@ -289,19 +255,5 @@
 	ASSERT(mutex_locked(&area->lock));
 
-	if (area->flags & AS_AREA_LATE_RESERVE) {
-		/*
-		 * In case of the late reserve areas, physical memory will not
-		 * be unreserved when the area is destroyed so we need to use
-		 * the normal unreserving frame_free().
-		 */
-		frame_free(frame);
-	} else {
-		/*
-		 * The reserve will be given back when the area is destroyed or
-		 * resized, so use the frame_free_noreserve() which does not
-		 * manipulate the reserve or it would be given back twice.
-		 */
-		frame_free_noreserve(frame);
-	}
+	frame_free_noreserve(frame);
 }
 
Index: kernel/generic/src/mm/backend_elf.c
===================================================================
--- kernel/generic/src/mm/backend_elf.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/src/mm/backend_elf.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -58,7 +58,4 @@
 static void elf_destroy(as_area_t *);
 
-static bool elf_is_resizable(as_area_t *);
-static bool elf_is_shareable(as_area_t *);
-
 static int elf_page_fault(as_area_t *, uintptr_t, pf_access_t);
 static void elf_frame_free(as_area_t *, uintptr_t, uintptr_t);
@@ -69,7 +66,4 @@
 	.share = elf_share,
 	.destroy = elf_destroy,
-
-	.is_resizable = elf_is_resizable,
-	.is_shareable = elf_is_shareable,
 
 	.page_fault = elf_page_fault,
@@ -219,15 +213,4 @@
 }
 
-bool elf_is_resizable(as_area_t *area)
-{
-	return true;
-}
-
-bool elf_is_shareable(as_area_t *area)
-{
-	return true;
-}
-
-
 /** Service a page fault in the ELF backend address space area.
  *
Index: kernel/generic/src/mm/backend_phys.c
===================================================================
--- kernel/generic/src/mm/backend_phys.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/src/mm/backend_phys.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -52,8 +52,4 @@
 static void phys_destroy(as_area_t *);
 
-static bool phys_is_resizable(as_area_t *);
-static bool phys_is_shareable(as_area_t *);
-
-
 static int phys_page_fault(as_area_t *, uintptr_t, pf_access_t);
 
@@ -63,7 +59,4 @@
 	.share = phys_share,
 	.destroy = phys_destroy,
-
-	.is_resizable = phys_is_resizable,
-	.is_shareable = phys_is_shareable,
 
 	.page_fault = phys_page_fault,
@@ -94,15 +87,4 @@
 	/* Nothing to do. */
 }
-
-bool phys_is_resizable(as_area_t *area)
-{
-	return false;
-}
-
-bool phys_is_shareable(as_area_t *area)
-{
-	return true;
-}
-
 
 /** Service a page fault in the address space area backed by physical memory.
Index: kernel/generic/src/mm/km.c
===================================================================
--- kernel/generic/src/mm/km.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/src/mm/km.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -233,6 +233,5 @@
  * @param[inout] framep	Pointer to a variable which will receive the physical
  *			address of the allocated frame.
- * @param[in] flags	Frame allocation flags. FRAME_NONE, FRAME_NO_RESERVE
- *			and FRAME_ATOMIC bits are allowed.
+ * @param[in] flags	Frame allocation flags. FRAME_NONE or FRAME_NO_RESERVE.
  * @return		Virtual address of the allocated frame.
  */
@@ -244,5 +243,5 @@
 	ASSERT(THREAD);
 	ASSERT(framep);
-	ASSERT(!(flags & ~(FRAME_NO_RESERVE | FRAME_ATOMIC)));
+	ASSERT(!(flags & ~FRAME_NO_RESERVE));
 
 	/*
@@ -256,8 +255,6 @@
 		ASSERT(page);	// FIXME
 	} else {
-		frame = (uintptr_t) frame_alloc(ONE_FRAME,
-		    FRAME_LOWMEM | flags);
-		if (!frame)
-			return (uintptr_t) NULL;
+		frame = (uintptr_t) frame_alloc_noreserve(ONE_FRAME,
+		    FRAME_LOWMEM);
 		page = PA2KA(frame);
 	}
Index: kernel/generic/src/proc/program.c
===================================================================
--- kernel/generic/src/proc/program.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/src/proc/program.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -79,14 +79,8 @@
 	 * Create the stack address space area.
 	 */
-	uintptr_t virt = (uintptr_t) -1;
-	uintptr_t bound = USER_ADDRESS_SPACE_END - (STACK_SIZE_USER - 1);
-
-	/* Adjust bound to create space for the desired guard page. */
-	bound -= PAGE_SIZE;
-
+	uintptr_t virt = USTACK_ADDRESS;
 	as_area_t *area = as_area_create(as,
-	    AS_AREA_READ | AS_AREA_WRITE | AS_AREA_CACHEABLE | AS_AREA_GUARD |
-	    AS_AREA_LATE_RESERVE, STACK_SIZE_USER, AS_AREA_ATTR_NONE,
-	    &anon_backend, NULL, &virt, bound);
+	    AS_AREA_READ | AS_AREA_WRITE | AS_AREA_CACHEABLE,
+	    STACK_SIZE, AS_AREA_ATTR_NONE, &anon_backend, NULL, &virt, 0);
 	if (!area) {
 		task_destroy(prg->task);
@@ -99,5 +93,5 @@
 	kernel_uarg->uspace_entry = (void *) entry_addr;
 	kernel_uarg->uspace_stack = (void *) virt;
-	kernel_uarg->uspace_stack_size = STACK_SIZE_USER;
+	kernel_uarg->uspace_stack_size = STACK_SIZE;
 	kernel_uarg->uspace_thread_function = NULL;
 	kernel_uarg->uspace_thread_arg = NULL;
Index: kernel/generic/src/proc/scheduler.c
===================================================================
--- kernel/generic/src/proc/scheduler.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/src/proc/scheduler.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -92,5 +92,5 @@
 	else
 		fpu_disable();
-#elif defined CONFIG_FPU
+#else
 	fpu_enable();
 	if (THREAD->fpu_context_exists)
@@ -327,5 +327,5 @@
 		THREAD->kcycles += get_cycle() - THREAD->last_cycle;
 		
-#if (defined CONFIG_FPU) && (!defined CONFIG_FPU_LAZY)
+#ifndef CONFIG_FPU_LAZY
 		fpu_context_save(THREAD->saved_fpu_context);
 #endif
Index: kernel/generic/src/proc/task.c
===================================================================
--- kernel/generic/src/proc/task.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/generic/src/proc/task.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -125,14 +125,4 @@
 {
 	size_t tasks_left;
-
-	if (ipc_phone_0) {
-		task_t *task_0 = ipc_phone_0->task;
-		ipc_phone_0 = NULL;
-		/*
-		 * The first task is held by kinit(), we need to release it or
-		 * it will never finish cleanup.
-		 */
-		task_release(task_0);
-	}
 	
 	/* Repeat until there are any tasks except TASK */
@@ -206,5 +196,5 @@
 	task->ucycles = 0;
 	task->kcycles = 0;
-
+	
 	task->ipc_info.call_sent = 0;
 	task->ipc_info.call_received = 0;
Index: release/Makefile
===================================================================
--- release/Makefile	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ release/Makefile	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -32,5 +32,5 @@
 SRC_ARCHIVE = HelenOS-$(RELEASE).tar.bz2
 
-PROFILES = amd64 arm32/integratorcp arm32/gta02 arm32/beagleboardxm ia32 \
+PROFILES = amd64 arm32/GXemul arm32/integratorcp arm32/gta02 ia32 \
     ia64/i460GX ia64/ski mips32/GXemul mips32/msim ppc32 \
     sparc64/ultra
